local _
local rematch = Rematch
local old_PLAYER_TARGET_CHANGED = rematch.PLAYER_TARGET_CHANGED
local saved
local hhh
local C_PetJournal = C_PetJournal
rematch:InitModule(function()
	saved = RematchSaved
end)

local function my_PLAYER_TARGET_CHANGED(self)
	--local saved = RematchSaved
	local temp=GetCurrentMapAreaID()
	SetMapToCurrentZone()
	--print(temp)
	--local temp1=GetCurrentMapAreaID()
	--print(temp1)
	--can't make temp1 and temp2 different
	SetMapByID(temp)
	--GetRealZoneText()
	local tst = GetMapInfo()
	local where_to_execute = 955
	local place = GetMapNameByID(where_to_execute)
	--if temp == 905 then print ("It's Shrine of Seven Stars") end
	--if temp == 955 then print ("It's Celestila Tournament") end
	--if temp == 903 then print ("It's Shrine of Two Moons") end
	--if temp == 976 then print ("It's Horde Garrison") end
	--if temp == 321 then print ("It's Orgrimmar") end
	if temp == where_to_execute then
		if saved["Heal team"] then
			local healID = saved["Heal team"][1][1]
			local hhealth,hmaxHealth = C_PetJournal.GetPetStats(healID)
			local numDead = 0
			local numInjured = 0
			local numPets = C_PetJournal.GetNumPets()
			if hmaxHealth == hhealth then
				--rematch:LoadTeam("Heal team")
				local most_injured_ID = nil
				local most_injured_deficit = 0
				local least_injured_ID = nil
				local least_injured_deficit = 10000
				for i=1, numPets do
					local petID = C_PetJournal.GetPetInfoByIndex(i)
					if petID then
						local health, maxHealth = C_PetJournal.GetPetStats(petID)
						if health == 0 then numDead = numDead + 1 end
						if health < maxHealth and health > 0 then
							local deficit = maxHealth - health
							numInjured = numInjured + 1
							if most_injured_deficit < deficit then
								most_injured_ID = petID
								most_injured_deficit = deficit
							end
							if least_injured_deficit > deficit then
								least_injured_ID = petID
								least_injured_deficit = deficit
							end
						end
					end
				end
				if numInjured > 0 then
					C_PetJournal.SetPetLoadOutInfo(1, healID)
					C_PetJournal.SetPetLoadOutInfo(2, most_injured_ID)
					if numInjured > 1 then
						C_PetJournal.SetPetLoadOutInfo(3, least_injured_ID)
					end
				end
				--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead)))
			else --you asked for this by letting your healing pet to get injured
				hhh = {}
				for i=1, numPets do
					local petID = C_PetJournal.GetPetInfoByIndex(i)
					if petID then
						local health,maxHealth = C_PetJournal.GetPetStats(petID)
						if health == 0 then numDead = numDead + 1 end
						if health < maxHealth and health > 0 then
							numInjured = numInjured + 1
							hhh[numInjured] = petID
						end
					end
				end
				if hhealth == 0 then
					DEFAULT_CHAT_FRAME:AddMessage("Pet intended to do the healing is dead")
				else
					for i=1, 3 do
						C_PetJournal.SetPetLoadOutInfo(i, hhh[i])
					end
					C_PetJournal.SetPetLoadOutInfo(1, healID)
				end
				--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead)))
			end
			DEFAULT_CHAT_FRAME:AddMessage("You have " .. numInjured .. " injured pets and " .. numDead .. "dead pets." )
			--print(format("You have %s injured pets and %s dead pets.",tostring(numInjured),tostring(numDead))) --printing here doesn't seem to work
			if numInjured == 0 then
				local name,npcID = rematch:GetUnitNameandID("target")
				if saved[npcID] then
					DEFAULT_CHAT_FRAME:AddMessage("Since there are no injured pets, loaded team for " .. name)
					rematch:LoadTeam(npcID)
				end
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("Healing team not defined")
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("It's " .. GetRealZoneText() .. " or " .. tst .. " with zone ID " .. temp .. ", a loading of different team for healing is meant for zone with ID " .. where_to_execute .. " - " .. place)
	end
end

function rematch:PLAYER_TARGET_CHANGED()
	if IsShiftKeyDown() then
		local name,npcID = rematch:GetUnitNameandID("target")
		if saved[npcID] then
			DEFAULT_CHAT_FRAME:AddMessage("There's a saved team meant for defeating " .. name)
		end
		--rematch.recentTarget = nil
		return my_PLAYER_TARGET_CHANGED(self)
	else
		return old_PLAYER_TARGET_CHANGED(self)
	end
end